-- Version 1.0 of ColorConnectionsMaker by HerrVincling, 13.08.2021

CCM = class( nil )
CCM.maxChildCount = -1
CCM.maxParentCount = -1
CCM.connectionInput = sm.interactable.connectionType.logic
CCM.connectionOutput = sm.interactable.connectionType.logic -- none, logic, power, bearing, seated, piston, any
CCM.colorNormal = sm.color.new(0x7F7F7Fff)
CCM.colorHighlight = sm.color.new(0xa4a4a4ff)
--GenericClass.poseWeightCount = 1

--[[ client ]]
function CCM.client_onCreate(self )
end

function CCM.client_onRefresh(self )
 self:client_onCreate()
end

function CCM.client_onUpdate(self, deltaTime )
    if self.interactable.active then
        self.interactable:setUvFrameIndex(6 + self.var1)
    else
        self.interactable:setUvFrameIndex(0 + self.var1)
    end
end

function CCM.client_onInteract(self, character, state )
    if state then
        local childs = self.interactable:getChildren()
        local parents = self.interactable:getParents()
        if #childs>0 then
            self.active = true
            self.color1 = self.shape:getColor()
            for id, child in pairs(childs) do
                self.color2 = child:getShape():getColor()
                self.partner = child:getShape()
            end
        elseif #parents>0 then
            self.active = true
            self.color2 = self.shape:getColor()
            for id, parent in pairs(parents) do
                self.color1 = parent:getShape():getColor()
                self.partner = parent:getShape()
            end
        end
    end
end

--EE7BF0 light pink
--EEAF5C light orange

--[[ server ]]
function CCM.server_onCreate(self )
    self.var1 = 0
    self.active = false
    self.color1 = nil
    self.color2 = nil
    self.partner = nil
end

function CCM.server_onRefresh(self )
 self:server_onCreate()
end

function CCM.server_onFixedUpdate(self, deltaTime )
    if self.active then
        self.active = false
        local shapes = self.shape:getBody():getCreationShapes()
        local color1 = {}
        local color2 = {}
        if #shapes>0 then
            for id, shape in pairs(shapes) do
                if shape:getColor() == self.color1 then
                    if shape ~= self.shape and shape ~= self.partner then
                        table.insert(color1, shape)
                    end
                end
                if shape:getColor() == self.color2 then
                    if shape ~= self.shape and shape ~= self.partner then
                        table.insert(color2, shape)
                    end
                end
            end
            for id0, i0 in pairs(color1) do
                for id1, i1 in pairs(color2) do
                    i0:getInteractable():connect(i1:getInteractable())
                end
            end
        end
    end
end