-- Version 1.0 of ConnectionCopyPaste by HerrVincling, 07.08.2021

FLG = class( nil )
FLG.maxChildCount = -1
FLG.maxParentCount = -1
FLG.connectionInput = sm.interactable.connectionType.logic
FLG.connectionOutput = sm.interactable.connectionType.logic -- none, logic, power, bearing, seated, piston, any
FLG.colorNormal = sm.color.new(0xCF11D2ff)
FLG.colorHighlight = sm.color.new(0xEE7BF0ff)
--GenericClass.poseWeightCount = 1

--[[ client ]]
function FLG.client_onCreate(self )
end

function FLG.client_onRefresh(self )
 self:client_onCreate()
end

function FLG.client_onUpdate(self, deltaTime )
    if self.interactable.active then
        self.interactable:setUvFrameIndex(6 + self.var1)
    else
        self.interactable:setUvFrameIndex(0 + self.var1)
    end
end

function FLG.client_onInteract(self, character, state )
    self.copypaste = true
end

--EE7BF0 light pink
--EEAF5C light orange

--[[ server ]]
function FLG.server_onCreate(self )
    self.var1 = 0
    self.copypaste = false
    self.copygate = self.interactable
    self.pastegate = self.interactable
    self.error = false
end

function FLG.server_onRefresh(self )
 self:server_onCreate()
end

function FLG.server_onFixedUpdate(self, deltaTime )
    if (self.copypaste) then

        self.copygate = nil
        self.pastegate = nil
        self.error = false
        local interactables = self.shape:getBody():getCreationShapes()
        if #interactables>0 then
            for id, shape in pairs(interactables) do
                local i0 = shape:getInteractable()
                if (shape:getColor() == sm.color.new(0xEE7BF0ff) and (i0:getType() == "logic" or i0:getType() == "scripted" or i0:getType() == "button" or i0:getType() == "lever")) then
                    if (self.copygate ~= nil and shape:getInteractable() ~= nil) then
                        self.shape:setColor(sm.color.new(0xD02525ff))
                        self.error = true
                    end
                    self.copygate = shape:getInteractable()
                end
            end
            if (self.copygate ~= nil and not self.error) then
                for id, shape in pairs(interactables) do
                    local i0 = shape:getInteractable()
                    if (shape:getColor() == sm.color.new(0xEEAF5Cff) and (i0:getType() == "logic" or i0:getType() == "scripted" or i0:getType() == "button" or i0:getType() == "lever")) then
                        self.pastegate = shape:getInteractable()

                        if (self.pastegate ~= nil) then
                            local children = self.copygate:getChildren()
                            for id, child in pairs(children) do
                                self.pastegate:connect(child)
                            end
                            local parents = self.copygate:getParents()
                            for id, parent in pairs(parents) do
                                parent:connect(self.pastegate)
                            end
                            --print("Successfully connected")
                            self.shape:setColor(sm.color.new(0xCF11D2ff))
                        end
                    end
                end
            end
        end
        self.copypaste = false
    end
end