-- Version 1.0 of ParallelConnections by HerrVincling, 09.08.2021

PCS = class( nil )
PCS.maxChildCount = -1
PCS.maxParentCount = -1
PCS.connectionInput = sm.interactable.connectionType.logic
PCS.connectionOutput = sm.interactable.connectionType.logic -- none, logic, power, bearing, seated, piston, any
PCS.colorNormal = sm.color.new(0x0A3EE2ff)
PCS.colorHighlight = sm.color.new(0x4C6FE3ff)
--GenericClass.poseWeightCount = 1

--[[ client ]]
function PCS.client_onCreate(self )
end

function PCS.client_onRefresh(self )
 self:client_onCreate()
end

function PCS.client_onUpdate(self, deltaTime )
    if self.interactable.active then
        self.interactable:setUvFrameIndex(6 + self.var1)
    else
        self.interactable:setUvFrameIndex(0 + self.var1)
    end
end

function PCS.client_onInteract(self, character, state )
    if state then
        self.active = not self.active
    end
end

--EE7BF0 light pink
--EEAF5C light orange

--[[ server ]]
function PCS.server_onCreate(self )
    self.var1 = 0
    self.active = false
end

function PCS.server_onRefresh(self )
 self:server_onCreate()
end

function PCS.server_onFixedUpdate(self, deltaTime )
    self.interactable.active = self.active
    if self.active then
        local shapes = self.shape:getBody():getCreationShapes()
        if #shapes>0 then
            for id, shape in pairs(shapes) do
                local i0 = shape:getInteractable()
                if (i0 ~= nil) then
                    if (shape:getColor() == sm.color.new(0x4A4A4Aff) and (i0:getType() == "logic" or i0:getType() == "scripted" or i0:getType() == "button" or i0:getType() == "lever")) then
                        for id, child in pairs(i0:getChildren()) do
                            if(child:getShape():getColor() == sm.color.new(0x7F7F7Fff)) then

                                --print("CONNECT2!")
                                local black = {}

                                local search = true
                                local newNeighbours = shape:getNeighbours()
                                local neighbours = newNeighbours
                                local newLG = false
                                while search do
                                    neighbours = newNeighbours
                                    search = false
                                    for id, neighbour in pairs(neighbours) do
                                        local i1 = neighbour:getInteractable()
                                        if (i1 ~= nil and neighbour:getColor() == sm.color.new(0x222222ff)) then
                                            newLG = true
                                            for id, blackLG in pairs(black) do
                                                if (blackLG == i1) then
                                                    newLG = false
                                                end
                                            end
                                            if newLG then
                                                newNeighbours = neighbour:getNeighbours()
                                                table.insert(black, i1)
                                                search = true
                                            end
                                        end
                                    end
                                end
                                --print(black)



                                local white = {}

                                search = true
                                newNeighbours = child:getShape():getNeighbours()
                                neighbours = newNeighbours
                                local newLG = false
                                while search do
                                    neighbours = newNeighbours
                                    search = false
                                    for id, neighbour in pairs(neighbours) do
                                        local i1 = neighbour:getInteractable()
                                        if (i1 ~= nil and neighbour:getColor() == sm.color.new(0xEEEEEEff)) then
                                            newLG = true
                                            for id, blackLG in pairs(white) do
                                                if (blackLG == i1) then
                                                    newLG = false
                                                end
                                            end
                                            if newLG then
                                                newNeighbours = neighbour:getNeighbours()
                                                table.insert(white, i1)
                                                search = true
                                            end
                                        end
                                    end
                                end
                                --print(white)


                                if (#black == #white) then
                                    for i = 1, #black, 1 do
                                        black[i]:connect(white[i])
                                    end
                                end



                                --print(child:getShape():getLocalPosition()['x'])
                                child:getShape():setColor(sm.color.new(0xEEEEEEff))

                            end
                        end
                    end
                end
            end
        end
    end
end